#ifndef ASSYM_HPP_
#define ASSYM_HPP_
#define assym_hpp_version "$Revision: 1.14 $"

#include "ThreadGlobals.hpp"
#include <algorithm>
#include "Watching.hpp"
#include "IFStream.hpp"
#include "Hash.hpp"
#include "AssignInfos.hpp"

using std::pair;

//better would be to decide dynamic
#define ASSYM_HYPER_BIN 1


class Assym{

	typedef uint64_t levl_t;
	struct VInf{
		levl_t reasn;
		levl_t root;
	};



	TGlobals&				glob;
	BitVector<Variable>& 	var_flgs;
	VarVal&					vals;
	const	var_hp_t&	act_hp;
	ExtClses	&			clses;
	VecOfLists<EWtch,Literal>&wtching;
	vector<uint64_t>&		vifo;
	vector<Literal>&		units_out;
	vector<Subsumd>&		subsum_out;

protected:
	//BinCrossSum								count_ones;
	VInf* vInfP(const Variable& v){asrt(v.idx() * 2 < vifo.size());
		return  (VInf*) &(vifo[v.idx() << 1]);}
	VInf* vInfP(const Literal& l){return vInfP(l.toVar());}

	vector<Literal>			ass_stck;

	struct ClsWrp{
		uint32_t bin		:1;
		uint32_t lit_cls	:31; //literal or clause

		ClsWrp(const Literal& l=TRUE_LIT):bin(1),lit_cls(l.idx()){}
		ClsWrp(const ClsP& c)		:bin(0),lit_cls(c.idx()){}
		bool isBin() const				{return bin;}
		Literal getLit() const			{asrt(isBin());return Literal(lit_cls);}
		ClsP getClp() const			{asrt(!isBin());return ClsP(lit_cls);}
	};

	const   var_act_t					hbin_over;
	vector<std::pair<Literal,ClsWrp> > 	prop_touched;
	vector<ECP >					prop_confl;
	uint32_t 							confl_strt;
	BinCrossSum						count_ones;

	enum Task{TAKE_MRKD,LEAVE,GO,NEWVERSION};

	//void cleanClsDB();
	//bool bcpAt0(Literal lit);
	Task propLongs(const Literal* lits);
	//void collStrongReasons(const ClsWrp& clw, const Literal& w, levl_t& sr,levl_t& roots);
	void collReasons(Cls& cls, const Literal& except_w, levl_t& reason, levl_t& root);
	uint32_t collRsnsCountMrkd(Cls& cls, const Literal& w, levl_t& reason, levl_t& root);
	bool enqBcpBin(Literal lit, const levl_t& reason, const levl_t& root);
	void enqueue(const Literal& l,const levl_t& reason, const levl_t& root){ asrt(vals.litUkwn(l));
		LOG2("Enqueue lit " << l.toDIMACS() << " with reason " << reason << " and root " << root);
		VInf* vinf		= vInfP(l);
		vinf->reasn		= reason;
		vinf->root		= root;
		vals.setValue(l); asrt(!var_flgs.isSet(l.toVar())||powOf2(reason));
		ass_stck.push_back(l);}


	void undoAssCompl();
	void undoAss();

	//shrinkyWinky helpers
	bool	getAltReason(const Literal& l, const ClsWrp& clw,levl_t& reas_out, levl_t& root_out);
	void 	updateAllReasons(const Literal* lits, const uint32_t& end, const levl_t old, const levl_t repl);
	Task 	smpleChk(uint32_t& mrkd_c,const Literal* lits,const uint32_t& end);


	Task 	handleConflictingFor(const ECP& orig,Literal* lits, uint32_t& end, uint32_t& mrkd, levl_t& all_levs);
	Task 	propFlippedLits(Literal* lits, uint32_t& sz, const ECP& clp);
	//bool	recomputeReasons();
	Task	enqFlippedLits(Literal* lits, uint32_t& sz, levl_t& all_lvls, const ECP& orig);
	//Task	reEnqFlippedLits(Literal* lits, uint32_t& sz, levl_t& all_lvls);

	void clearProp();

	void	addBins(const Literal& lit, levl_t roots, const Literal* lits);
	void	addBins(const Literal& lit, VInf* ai, levl_t roots, const Literal* lits);


public:
	void clear(){clearProp();}

	uint32_t shrinkyWinky(const ECP& orig);
	//void justHpyerBin(const Literal& root);

	Assym(TGlobals& globals,BitVector<Variable>& flgs,VarVal&	vls,ExtClses& eclses,vector<uint64_t>& space,const var_hp_t& v_act_hp,
			VecOfLists<EWtch,Literal>& watching,vector<Literal>& unitsout,vector<Subsumd>& subsumed_out):
		glob(globals),var_flgs(flgs),vals(vls),act_hp(v_act_hp),clses(eclses),wtching(watching),vifo(space),units_out(unitsout),subsum_out(subsumed_out)
		,hbin_over(act_hp.getBest().percent(glob.sets.hyper_bin_act_threash)),confl_strt(0){}

	friend class Settings;
};

const char*  assym_cpp_version();
#endif /* ASSYM_HPP_ */
