/*
 * ElimClses.hpp
 *
 *  Created on: 07.11.2010
 *      Author: stephan
 */

#ifndef ELIMCLSES_HPP_
#define ELIMCLSES_HPP_
#define elimclses_hpp_version "$Revision: 1.5 $"

#include "Types.hpp"
#include "ExtCls.hpp"
#include <vector>

enum ElimType{VAR_ELIM=0,BLKD_CLS=1,VAR_REPL=2,VAR_ENSURE_VAL=3};
class ElimClses{
	struct ClsIfo{
		uint32_t type : 2;
		uint32_t strt	: 30;
		ClsIfo(uint32_t start, ElimType t):type(t),strt(start){}
	};
	vector<Literal>  	lits;
	vector<ClsIfo>		cifos;
	Literal* 			bw_iter;

	Literal* newCls(const uint32_t& sz,ElimType type){
			uint32_t start = lits.size();
			cifos		.push_back(ClsIfo(start,type));
			lits		.resize(start+sz);
			return &(lits[start]);}
public:
	ElimClses():bw_iter(NULL){}
	void remember(const Variable& a){
		LOG2("Remember variable " << a.toDIMACS());
		Literal* strt 	= newCls(1,VAR_ENSURE_VAL);
		*strt			= a.toPosLit();}

	void remember(const Literal& a, const Literal& b,ElimType type){
		Literal* strt = newCls(2,type);  LOG2("Remember bin cls " << a.toDIMACS() << " " << b.toDIMACS());
		*strt++ = a; *strt=b;}

	/*void remember(const Literal lits[], const uint32_t& sz,ElimType type){ asrt(type!=BLKD_CLS);
		Literal* strt = newCls(sz,type); LOG2("Remember cls of size " << sz << " with type " << type);
		for(uint32_t i=0;i!=sz;++i){*strt++ = lits[i];}}*/


	void remember(const Literal& w1, Cls& cls, const uint32_t& sz, const Literal& anc, ElimType type){
		LOG2("Remember cls of size " << sz << " with type " << type);

		Literal* strt 	= newCls(sz,type); LOG2("Remember cls of size " << sz << " with ancor " << anc.toDIMACS());
		Literal cnd		= cls.otherWatcher(w1);
		*strt++			= anc;

		if(w1 != anc)	{*strt++ = w1;}
		if(cnd != anc)	{*strt++ = cnd;}

		ClsLit* clit = cls.uwBeg();
		do{
			Literal lit(clit->lit);
			if(lit!=anc){*strt++ = lit;}
		}while((clit++)->has_next);
	}

	void rememberBlkd(const Literal& w1, Cls& cls, const uint32_t& sz, const Literal& anc){
		LOG2("Remember blocked cls of size " << sz << " with ancor " << anc.toDIMACS());
		remember(w1,cls,sz,anc,BLKD_CLS);}

	void initClsPopping(){if(!cifos.empty()){bw_iter=lits.end().base();}}
	bool popCls(Literal*& beg_out, Literal*& end_out,ElimType& type){ asrt(bw_iter != NULL || cifos.empty());
		if(cifos.empty()) return false;
		type		= ElimType(cifos.back().type);
		beg_out = &lits[cifos.back().strt]; cifos.pop_back();
		end_out	= bw_iter;
		bw_iter	= beg_out;
		return 	true;
	}

};


#endif /* ELIMCLSES_HPP_ */
