
#ifndef EINFO_HPP_
#define EINFO_HPP_


template<class T,class I>
struct einfo: protected std::vector<T>{
	typedef std::vector<T> super;
	uint32_t size() const			{return super::size();}
	uint32_t capa() const			{return super::capacity();}
	bool inRange(const I& i)const 	{return i.idx() < size();}
	void reserve(const uint32_t& r){
		if(r>super::capacity())super::reserve(r);}
	void ensureSize(const uint32_t& s,const T& t=T()){
		asrt(s >= size());//super::reserve(s);
		super::resize(s,t);}

	void ensureSizeExplicit(const uint32_t& s){
		asrt(s >= size());
		super::reserve(s); uint32_t idx;
		while((idx=size(),idx<s)){super::push_back(T(idx));}
	}

	const T& operator[](const I& i) const {
		asrt(inRange(i)); return super::operator [](i.idx());}
	T& operator[](const I& i) {
		asrt(inRange(i)); return super::operator [](i.idx());}

	const T& byIndex(const uint32_t& idx) const {asrt(idx < size());
		return super::operator[](idx);}
	T& byIndex(const uint32_t& idx) {asrt(idx < size());
		return super::operator[](idx);}

	I 	grow(const T& t){super::push_back(t);return I(size()-1);}
	void shrink(){asrt(!super::empty());super::pop_back();}
	//I	newUnused() const {return I(size());}
	void  setAll(const T& t){
		for(uint32_t i=size();i--;){super::operator[](i) = t;}}
};


const uint16_t zero16	= 0;
const uint16_t max16	= ~zero16;
const uint32_t zero32 	= 0;
const uint32_t max32	= ~zero32;
const uint64_t zero64 	= 0;
const uint64_t max64	= ~zero64;

const int KILO = 1 << 10;
const int MEGA = 1 << 20;



#endif /* EINFO_HPP_ */
